import urllib
import json
import redis
import logging


from utils import parse_branch


BRANCH_TIPS = "https://api.launchpad.net/devel/charm?ws.op=getBranchTips"
CHARM_DIR = ""

log = logging.getLogger("charm.launchpad")


def available_charms():
    #charm_data = urllib.urlopen(BRANCH_TIPS).read()
    #charm_data = json.loads(charm_data)

    charm_data = json.loads(open("charms.json").read())

#    charms = {}

    for repo, commit, series in charm_data:
        _, branch_name = repo.rsplit("/", 1)

        data = parse_branch(repo, series, commit)
        if not data:
            log.debug("Unable to parse repo %s", repo)
            continue

#        if not repo_owner in ("~charmers",):
#            log.debug("Skipped r-O %s", repo)
#            continue

        if data["bname"] not in ("trunk", "trunk-1"):
            log.debug("Skipped branch %s", repo)
            continue
        yield data

 #       if not series:
 #           log.debug("Skipped r-S %s", repo)
 #           continue

        # Prefer trunk-1 over trunk (has series), need to keep in mem
        # to filter this.
#        if data["name"] in charms:
#            if data["bname"] == "trunk-1":
#                charms[data["name"]] = data
#        else:
#            charms[data["name"]] = data




def queue_charms(server):
    for charm in available_charms():
        added = server.sadd("bzr-fetch", json.dumps(charm))
        if added:
            log.info("Queued %s", charm)


def main():
    logging.basicConfig(level=logging.DEBUG)
    server = redis.Redis()
    queue_charms(server)


if __name__ == '__main__':
    main()
